/*
 * The contents of this file are copyright 2012 Clinton Bale
 * <clinton.bale@gmail.com>
 *
 * This work is licensed under the Creative Commons "Attribution-Share Alike 3.0 Unported" License.
 * To view a copy of this license, visit http://creativecommons.org/licenses/by-sa/3.0/legalcode
 * or, send a letter to Creative Commons, 171 2nd Street, Suite 300, San Francisco, California, 94105, USA.
*/

#pragma once
#ifndef MAP_WRITER_H
#define MAP_WRITER_H

#include <windows.h>
#include <cstdio>

const int MAP_VERSION = 220;

enum face_t {
	TOP = 1,
	BOTTOM = 2,
	LEFT = 4,
	RIGHT = 8,
	FRONT = 16,
	BACK = 32,
	ALLFACES = 64
};

class MapFile
{
private:
	FILE* fp;

	void write_face(face_t side, int x, int y, int z, int length, int width, int height, const char* texture);
	void write_face(face_t side, int x, int y, int z, int size, int height, const char* texture);
public:
	MapFile(const char*);	
	~MapFile(void);

	bool create();
	bool close();

	void create_brush(int x, int y, int z, int length, int width, int height, const char* texture, int nullFaces);	
};

#endif //MAP_WRITER_H
